{-# OPTIONS -fglasgow-exts #-}

module StateT(StateT(StateT, runStateT), StateMonad(update, fetch), StateType(initialState)) where
 import Monad
 import AuxTypes

 newtype StateT s m a	= StateT { runStateT :: s -> m (a, s)}

 instance Monad m => Monad (StateT s m) where
	return a		= StateT (\s -> return (a, s))
	StateT m >>= k		= StateT (\s0 -> do (a, s1) <- m s0
 				                    runStateT (k a) s1)

 instance MonadT (StateT s) where
	lift c		= StateT (\s -> do {x <- c; return (x, s)}) 

 class Monad m => StateMonad s m where
	fetch		:: m s
	update		:: (s -> s) -> m ()

 instance Monad m => StateMonad s (StateT s m) where
	fetch		= StateT (\s -> return (s,s))
	update f	= StateT (\s -> return ((), f s))

 class StateType s where
        initialState    :: s

 instance (StateType s, Monad m, RunMonad m) => RunMonad (StateT s m) where
        run (StateT a)        = case run (a initialState) of
                                      Ok (a, s) -> Ok a
                                      Error x   -> Error x 
